unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

const
    MM_MAX_NUMAXES = 16;   // font embed

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

  PDesignVector = ^TDesignVector;       // font embed
  TDesignVector = packed record         // font embed
      dvReserved: DWORD;                  // font embed
      dvNumAxes: DWORD;                   // font embed
      dvValues: array[0..MM_MAX_NUMAXES-1] of Longint;     // font embed
  end;

  function AddFontMemResourceEx(p1: Pointer; p2: DWORD; p3: PDesignVector; p4: LPDWORD): THandle; stdcall external 'gdi32.dll' name 'AddFontMemResourceEx';
  function RemoveFontMemResourceEx(p1: THandle): BOOL; stdcall external 'gdi32.dll' name 'RemoveFontMemResourceEx';

var
  Form1: TForm1;

implementation

{$R *.lfm}

function LoadResourceFontByName( const ResourceName : string; ResType: PChar ) : Boolean;
var
  ResStream  : TResourceStream;
  FontsCount : DWORD;
begin
  ResStream := TResourceStream.Create(hInstance, ResourceName, ResType);
  try
    Result  := (AddFontMemResourceEx(ResStream.Memory, ResStream.Size, nil, @FontsCount) <> 0);
  finally
    ResStream.Free;
  end;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  if LoadResourceFontByName('LOKICOLA', RT_RCDATA) then
  begin
    Label1.Font.Name := 'Loki Cola';
    Label1.Caption := Label1.Font.Name;
  end;
end;

end.

